package com.gingersoft.gsa.cloud.download.mvp.model;

import android.app.Application;
import android.content.Context;

import com.gingersoft.gsa.cloud.base.common.bean.BaseResult;
import com.gingersoft.gsa.cloud.base.common.bean.FoodBean;
import com.gingersoft.gsa.cloud.database.bean.Food;
import com.gingersoft.gsa.cloud.database.utils.FoodDaoUtils;
import com.gingersoft.gsa.cloud.download.mvp.model.bean.ComboRespone;
import com.gingersoft.gsa.cloud.download.mvp.model.bean.FoodModifierRespone;
import com.gingersoft.gsa.cloud.download.mvp.model.bean.FunctionRespone;
import com.gingersoft.gsa.cloud.download.mvp.model.bean.ModifierRespone;
import com.gingersoft.gsa.cloud.download.mvp.model.service.DownloadService;
import com.google.gson.Gson;
import com.jess.arms.integration.IRepositoryManager;
import com.jess.arms.mvp.BaseModel;
import com.jess.arms.di.scope.ActivityScope;
import javax.inject.Inject;
import com.gingersoft.gsa.cloud.download.mvp.contract.DownloadContract;

import java.util.List;

import io.reactivex.Observable;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 12/26/2019 17:59
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
@ActivityScope
public class DownloadModel extends BaseModel implements DownloadContract.Model {
    @Inject
    Gson mGson;
    @Inject
    Application mApplication;

    @Inject
    public DownloadModel(IRepositoryManager repositoryManager) {
        super(repositoryManager);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        this.mGson = null;
        this.mApplication = null;
    }

    @Override
    public List<Food> queryDB_FoodGroupList(Context context) {
        FoodDaoUtils foodDaoUtils = new FoodDaoUtils(context);
        return foodDaoUtils.queryFoodGroupByQueryBuilder();
    }

    @Override
    public List<Food> queryDB_FoodList(Context context, int parentId) {
        FoodDaoUtils foodDaoUtils = new FoodDaoUtils(context);
        return foodDaoUtils.queryFoodByQueryBuilder(parentId);
    }

    @Override
    public Observable<FunctionRespone> downFunctionList() {
        return mRepositoryManager.obtainRetrofitService(DownloadService.class)
                .downFunctionList();
    }

    @Override
    public Observable<FoodBean> downFoodList(int restaurantId) {
        return mRepositoryManager.obtainRetrofitService(DownloadService.class)
                .downFoodList(restaurantId);
    }

    @Override
    public Observable<ModifierRespone> downModifier(int restaurantId) {
        return mRepositoryManager.obtainRetrofitService(DownloadService.class)
                .downModifier(restaurantId);
    }

    @Override
    public Observable<ComboRespone> downCombo(int restaurantId) {
        return mRepositoryManager.obtainRetrofitService(DownloadService.class)
                .downCombo(restaurantId);
    }

    @Override
    public Observable<FoodModifierRespone> downFoodModifier(int restaurantId) {
        return mRepositoryManager.obtainRetrofitService(DownloadService.class)
                .downFoodModifier(restaurantId);
    }


}